<?php
namespace OrganizationsManagement\Factory;
use Teknisa\Model\Teknisa\Entities\OmProdutoOrgElemento as ElementoOrgEntity;
use OrganizationsManagement\Util\Utilities as Utilities;
use Teknisa\Model\Util\NovoCodigo as NovoCodigo;
use OrganizationsManagement\Util\InstanceProvider;

class OrgElemento {

    public function save($elementProductOrg, $elementId, $currentOrgId, $dateNow, $codOperador, $expirationDate, $idAtivo = 'S', $dsobservacao)
    {
        $element = new ElementoOrgEntity();
        $novoCodigo = NovoCodigo::geraCodigo($currentOrgId, "OmProdutoOrgElemento", 1, 10, false, false);
        $element->setId($novoCodigo ? $novoCodigo : 1);
        $element->setCdoperinclusao($codOperador);
        $element->setCdoperultatu($codOperador);
        $element->setDtinclusao($dateNow);
        $element->setDtultatu($dateNow);
        $element->setIdativo($idAtivo);
        $element->setNrorg($currentOrgId);
        $element->setNrorginclusao($currentOrgId);
        $element->setNrorgultatu($currentOrgId);
        $element->setNrprodutoElementoId($elementId);
        $element->setNrprodutoOrgId($elementProductOrg);
        $element->setDtvalidade($expirationDate);
        $element->setDsobservacao($dsobservacao);

        return $element;
    }

    public function updateElementosManuais($contractCode, $dsobservacao, $codOperador, $expirationDate) {
        $query = "UPDATE OM_PRODUTO_ORG_ELEMENTO
                    SET DSOBSERVACAO = :DSOBSERVACAO,
                        DTULTATU     = SYSDATE,
                        CDOPERULTATU = :CDOPERULTATU,
                        DTVALIDADE =   TO_DATE(:DTVALIDADE, 'DD/MM/YYYY H24:MI:SS')
                  WHERE ID IN (
                    SELECT OE.ID FROM OM_PRODUTO_ELEMENTO PE
                    LEFT JOIN OM_PRODUTO_ORG_ELEMENTO OE ON OE.NRPRODUTO_ELEMENTO_ID = PE.ID
                    LEFT JOIN OM_PROD_ORG_ELEMENTO_CONTRATO PC ON PC.NRPRODUTO_ORG_ELEMENTO_ID = OE.ID
                    WHERE PC.IDALTERMANUAL = 'S' AND PC.NRSEQCONTRATO = :NRSEQCONTRATO
                  )";

        $params = array(
            'NRSEQCONTRATO' => $contractCode,
            'DSOBSERVACAO'  => $dsobservacao,
            'CDOPERULTATU'  => $codOperador,
            'DTVALIDADE'    => $expirationDate->format('d/m/Y H:i:s')
        );
        InstanceProvider::getEntityManager()->getConnection()->executeQuery($query, $params);
    }
}
