/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_VIAD                                                     */
/* Tabela : VIACESDIET                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_VIAD' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_VIAD
GO

CREATE TRIGGER DTULTATU_VIAD
ON VIACESDIET
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'VIACESDIET', null, 'CDVIACESDIET='+ CDVIACESDIET+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE VIACESDIET
      SET DTULTATUVIAD = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(VIACESDIET.CDVIACESDIET,0) = ISNULL(INSERTED.CDVIACESDIET,0)) AND
            (ISNULL(VIACESDIET.NMVIACESDIET,0) = ISNULL(INSERTED.NMVIACESDIET,0));
   END;
END;
GO

